---------------------------------------------------------------------------------
-- Alumne: Miguel Alvarez Lopez (bluesea)
-- Consultor: Juan Martnez Bolaos
-- Projecte: GESTIO D'UN DATA WAREHOUSE PER UNA CADENA DE BOTIGUES DE ROBA
---------------------------------------------------------------------------------

spool II-4-3-4_CreacioTaules_ERP.log;

-- Creaci de Taules

/*==============================================================*/
/* Table: PRODUCTES                                             */
/*==============================================================*/
CREATE TABLE PRODUCTES (
  ID_PROD		VARCHAR2(13)	NOT NULL,
  DESCRIPCIO		VARCHAR2(25)	NOT NULL,
  DATA_CAT		DATE		NOT NULL,
  CONSTRAINT PK_PRODUCTES PRIMARY KEY(ID_PROD)
);

comment on table PRODUCTES is
'Caracterstiques dels productes del catleg de la cadena de roba';

/*==============================================================*/
/* Table: PAIS                                                  */
/*==============================================================*/
CREATE TABLE PAIS (
  ID_PAIS		NUMBER(3)		NOT NULL,
  DESCRIPCIO		VARCHAR2(25)		NOT NULL,
  CONSTRAINT PK_PAIS PRIMARY KEY(ID_PAIS)
);  

comment on table PAIS is
'Relaci de paisos';

/*==============================================================*/
/* Table: REGIO                                                 */
/*==============================================================*/
CREATE TABLE REGIO (
  ID_REGIO		NUMBER(3)		NOT NULL,
  DESCRIPCIO		VARCHAR2(25)		NOT NULL,
  ID_PAIS		NUMBER(3)		NOT NULL,  
  CONSTRAINT PK_REGIO PRIMARY KEY(ID_REGIO),
  CONSTRAINT FK1_REGIO_PAIS FOREIGN KEY(ID_PAIS) REFERENCES PAIS(ID_PAIS)
);  

comment on table REGIO is
'Relaci de regions dels diferents paisos';

/*==============================================================*/
/* Table: CIUTAT                                                */
/*==============================================================*/
CREATE TABLE CIUTAT (
  ID_REGIO		NUMBER(3)		NOT NULL,
  ID_CIUTAT		NUMBER(3)		NOT NULL,
  DESCRIPCIO		VARCHAR2(25)		NOT NULL,
  CONSTRAINT PK_CIUTAT PRIMARY KEY(ID_REGIO, ID_CIUTAT),
  CONSTRAINT FK1_CIUTAT_REGIO FOREIGN KEY(ID_REGIO) REFERENCES REGIO(ID_REGIO)
);  

comment on table CIUTAT is
'Relaci de ciutats de les diferents regions dels paisos';

/*==============================================================*/
/* Table: BOTIGA                                                */
/*==============================================================*/
CREATE TABLE BOTIGA (
  ID_BOTIGA		NUMBER(3)	NOT NULL,
  EMAIL_GER		VARCHAR2(25)	NOT NULL,
  TREBALLADORS		NUMBER(3)	NOT NULL,
  FRANQUICIA		VARCHAR(1)	NOT NULL,
  FISICA		VARCHAR(1)	NOT NULL,
  REBAIXES		VARCHAR(1)	NOT NULL,
  DIUMENGE		VARCHAR(1)	NOT NULL,
  ID_CIUTAT		NUMBER(3)	NOT NULL,
  ID_REGIO		NUMBER(3)	NOT NULL,
  CONSTRAINT PK_BOTIGA PRIMARY KEY(ID_BOTIGA),
  CONSTRAINT FK1_BOTIGA_CIUTAT FOREIGN KEY (ID_REGIO, ID_CIUTAT) REFERENCES CIUTAT (ID_REGIO, ID_CIUTAT) ENABLE,
  CONSTRAINT CK_BOTIGA_FRANQUICIA CHECK (Franquicia IN ('S', 'N')),
  CONSTRAINT CK_BOTIGA_FISICA CHECK (Fisica IN ('S', 'N')),
  CONSTRAINT CK_BOTIGA_REBAIXES CHECK (Rebaixes IN ('S', 'N')),
  CONSTRAINT CK_BOTIGA_DIUMENGE CHECK (Diumenge IN ('S', 'N'))
);

comment on table BOTIGA is
'Caracterstiques de les botigues que formen part de la cadena de roba';

comment on column BOTIGA.FRANQUICIA is
'Valor "S" o "N"';

comment on column BOTIGA.FISICA is
'Valor "S" o "N"';

comment on column BOTIGA.REBAIXES is
'Valor "S" o "N"';

comment on column BOTIGA.DIUMENGE is
'Valor "S" o "N"';

/*==============================================================*/
/* Table: EXISTENCIA                                            */
/*==============================================================*/
CREATE TABLE EXISTENCIA (
  ID_BOTIGA		NUMBER(3)	NOT NULL,
  ID_PROD		VARCHAR2(13)	NOT NULL,
  QUANTITAT		NUMBER(3)	NOT NULL,
 CONSTRAINT PK_VENDA PRIMARY KEY(ID_BOTIGA, ID_PROD),
 CONSTRAINT FK1_VENDA_BOTIGA FOREIGN KEY(ID_BOTIGA) REFERENCES BOTIGA(ID_BOTIGA),
 CONSTRAINT FK2_VENDA_PRODUCTES FOREIGN KEY(ID_PROD) REFERENCES PRODUCTES(ID_PROD)
 );

comment on table EXISTENCIA is
'Existncies de productes a les botigues que formen part de la cadena de roba';

spool off;
