---------------------------------------------------------------------------------
-- Alumne: Miguel Alvarez Lopez (bluesea)
-- Consultor: Juan Martnez Bolaos
-- Projecte: GESTIO D'UN DATA WAREHOUSE PER UNA CADENA DE BOTIGUES DE ROBA
---------------------------------------------------------------------------------



/*****************************************************************
-- Nom:                 ALTABOTIGA
--
-- Descripci:          Dna d'alta una botiga de la cadena de de botigues de roba
--
-- Tasca: CU02-01
--
-- Parmetres entrada:
						pEMAIL_GER BOTIGA.EMAIL_GER%TYPE,
						pTREBALLADORS BOTIGA.TREBALLADORS%TYPE,
						pFRANQUICIA BOTIGA.FRANQUICIA%TYPE,      -- S/N
						pFISICA BOTIGA.FISICA%TYPE,              -- S/N
						pREBAIXES BOTIGA.REBAIXES%TYPE,          -- S/N
						pDIUMENGE BOTIGA.DIUMENGE%TYPE,          -- S/N
						pID_CIUTAT BOTIGA.ID_CIUTAT%TYPE,
						pID_REGIO BOTIGA.ID_REGIO%TYPE
						
--
-- Error controlats:   - BOTIGA duplicada
--
*****************************************************************/
CREATE OR REPLACE PROCEDURE "ALTABOTIGA" ( 
						pEMAIL_GER BOTIGA.EMAIL_GER%TYPE,
						pTREBALLADORS BOTIGA.TREBALLADORS%TYPE,
						pFRANQUICIA BOTIGA.FRANQUICIA%TYPE,
						pFISICA BOTIGA.FISICA%TYPE,
						pREBAIXES BOTIGA.REBAIXES%TYPE,
						pDIUMENGE BOTIGA.DIUMENGE%TYPE,
						pID_CIUTAT BOTIGA.ID_CIUTAT%TYPE,
						pID_REGIO BOTIGA.ID_REGIO%TYPE,
                                                RESPOSTA OUT NOCOPY VARCHAR2) 					   
  AS
  PARAMS VARCHAR2(1024);

BEGIN

  BEGIN
    RESPOSTA:='OK';
	PARAMS:=pEMAIL_GER||';'||pTREBALLADORS||';'||pFRANQUICIA||';'||pFISICA||';'||pREBAIXES||';'||pDIUMENGE||';'||
			pID_CIUTAT||';'||pID_REGIO;

	INSERT INTO BOTIGA (ID_BOTIGA,EMAIL_GER,TREBALLADORS,FRANQUICIA,FISICA,REBAIXES,DIUMENGE,ID_CIUTAT,ID_REGIO) 
	VALUES (TFC1.SEQ_BOTIGA.nextval,pEMAIL_GER,pTREBALLADORS,pFRANQUICIA,pFISICA,pREBAIXES,pDIUMENGE,pID_CIUTAT,pID_REGIO);
    
	ALTALOG ('ALTABOTIGA',PARAMS,RESPOSTA);
	
    EXCEPTION  
        WHEN DUP_VAL_ON_INDEX THEN
          RESPOSTA := 'La botiga ja existeix. ';
          DBMS_OUTPUT.PUT_LINE(RESPOSTA);
          ALTALOG ('ALTABOTIGA',PARAMS,RESPOSTA);
		  
        WHEN OTHERS THEN
          RESPOSTA := 'Error en alta botiga: (' || SQLCODE || ') ' || SQLERRM;
          DBMS_OUTPUT.PUT_LINE(RESPOSTA);  
		  ALTALOG ('ALTABOTIGA',PARAMS,RESPOSTA);		  
  END;

COMMIT;
END;
/

/*****************************************************************
-- Nom:                 MODIFICARBOTIGA
--
-- Descripci:          Modifica les dades duna botiga
--
-- Tasca: CU02-02
--
-- Parmetres entrada:
						pID_BOTIGA BOTIGA.IDBOTIGA%TYPE,
						pEMAIL_GER BOTIGA.EMAIL_GER%TYPE,
						pTREBALLADORS BOTIGA.TREBALLADORS%TYPE,
						pFRANQUICIA BOTIGA.FRANQUICIA%TYPE,         
						pFISICA BOTIGA.FISICA%TYPE,                 
						pREBAIXES BOTIGA.REBAIXES%TYPE,             
						pDIUMENGE BOTIGA.DIUMENGE%TYPE,             
						pID_CIUTAT BOTIGA.ID_CIUTAT%TYPE,
						pID_REGIO BOTIGA.ID_REGIO%TYPE
--
-- Error controlats:   - botiga no trobada
--
*****************************************************************/
CREATE OR REPLACE PROCEDURE "MODIFICARBOTIGA" ( 
						pID_BOTIGA BOTIGA.ID_BOTIGA%TYPE,
						pEMAIL_GER BOTIGA.EMAIL_GER%TYPE,
						pTREBALLADORS BOTIGA.TREBALLADORS%TYPE,
						pFRANQUICIA BOTIGA.FRANQUICIA%TYPE,
						pFISICA BOTIGA.FISICA%TYPE,
						pREBAIXES BOTIGA.REBAIXES%TYPE,
						pDIUMENGE BOTIGA.DIUMENGE%TYPE,
						pID_CIUTAT BOTIGA.ID_CIUTAT%TYPE,
						pID_REGIO BOTIGA.ID_REGIO%TYPE,		
	   	                                RESPOSTA OUT NOCOPY VARCHAR2) 					   
  AS
  COUNT_TMP INTEGER;
  PARAMS VARCHAR2(1024);
  
BEGIN

  BEGIN
    RESPOSTA:='OK';
	PARAMS:=pID_BOTIGA||';'||pEMAIL_GER||';'||pTREBALLADORS||';'||pFRANQUICIA||';'||pFISICA||';'||pREBAIXES||';'||pDIUMENGE||';'||
			pID_CIUTAT||';'||pID_REGIO;

	SELECT COUNT(*) INTO COUNT_TMP FROM BOTIGA WHERE ID_BOTIGA = pID_BOTIGA;

    IF (COUNT_TMP = 0) THEN
        RAISE NO_DATA_FOUND;
    END IF;
    
    UPDATE BOTIGA
    SET EMAIL_GER = pEMAIL_GER, 
		TREBALLADORS = pTREBALLADORS, 
		FRANQUICIA = pFRANQUICIA, 
		FISICA = pFISICA, 
		REBAIXES = pREBAIXES, 
		DIUMENGE = pDIUMENGE, 
		ID_CIUTAT = pID_CIUTAT, 
		ID_REGIO = pID_REGIO
	WHERE ID_BOTIGA = pID_BOTIGA;		

	ALTALOG ('MODIFICARBOTIGA',PARAMS,RESPOSTA);
	
	EXCEPTION  
        WHEN NO_DATA_FOUND THEN
           RESPOSTA := 'No existeix cap botiga amb identificador proporcionat.';
           DBMS_OUTPUT.PUT_LINE(RESPOSTA);
		   ALTALOG ('MODIFICARBOTIGA',PARAMS,RESPOSTA);
		   
        WHEN OTHERS THEN
          RESPOSTA := 'Error en la modificaci de la botiga : (' || SQLCODE || ') ' || SQLERRM;
          DBMS_OUTPUT.PUT_LINE(RESPOSTA);     
		  ALTALOG ('MODIFICARBOTIGA',PARAMS,RESPOSTA);
  END;

COMMIT;
END;
/


/*****************************************************************
-- Nom:                 ESBORRARBOTIGA
--
-- Descripci:          Esborra la botiga de la base de dades de la cadena de botigues de roba
--
-- Tasca: CU02-03
--
-- Parmetres entrada:
						pID_BOTIGA BOTIGA.ID_BOTIGA%TYPE,
--
-- Error controlats:   - botiga no trobada
--
*****************************************************************/
CREATE OR REPLACE PROCEDURE "ESBORRARBOTIGA" ( 
						pID_BOTIGA BOTIGA.ID_BOTIGA%TYPE,
					  	RESPOSTA OUT NOCOPY VARCHAR2) 					   
  AS
  COUNT_TMP INTEGER;
  PARAMS VARCHAR2(1024);
  
BEGIN

  BEGIN
    RESPOSTA:='OK';
	PARAMS:=pID_BOTIGA;
			
	SELECT COUNT(*) INTO COUNT_TMP FROM BOTIGA WHERE ID_BOTIGA = pID_BOTIGA;

    IF (COUNT_TMP = 0) THEN
        RAISE NO_DATA_FOUND;
    END IF;
    
	DELETE FROM BOTIGA WHERE ID_BOTIGA = pID_BOTIGA;

	ALTALOG ('ESBORRARBOTIGA',PARAMS,RESPOSTA);
		
	EXCEPTION  
        WHEN NO_DATA_FOUND THEN
           RESPOSTA := 'No existeix cap botiga amb identificador proporcionat.';
           DBMS_OUTPUT.PUT_LINE(RESPOSTA);
		   ALTALOG ('ESBORRARBOTIGA',PARAMS,RESPOSTA);
        
        WHEN OTHERS THEN
          RESPOSTA := 'Error esborrant botiga : (' || SQLCODE || ') ' || SQLERRM;
          DBMS_OUTPUT.PUT_LINE(RESPOSTA); 
		  ALTALOG ('ESBORRARBOTIGA',PARAMS,RESPOSTA);		  
  END;

COMMIT;
END;
/
