---------------------------------------------------------------------------------
-- Alumne: Miguel Alvarez Lopez (bluesea)
-- Consultor: Juan Martnez Bolaos
-- Projecte: GESTIO D'UN DATA WAREHOUSE PER UNA CADENA DE BOTIGUES DE ROBA
---------------------------------------------------------------------------------

spool III_2_b_Consulta_a.log;

/*****************************************************************
-- Nom:                 CONSANYMESBOTIGA
--
-- Descripci:          obtenir unes dades, donat un any i un mes concret el llistat
--                      de totes les botigues de la cadena incloent per a cada botiga
--
-- Parmetres entrada: No hi han. Per fem servir dues variables, anno i mes, per asignar els valors.
--
*****************************************************************/

SET LINESIZE 150
SET PAGESIZE 25

DEF anno = '2015';
DEF mmes = '08';

SELECT 
  TO_CHAR(v1.id_data,'YYYY') AS "ANY",
  TO_CHAR(v1.id_data,'MM') AS "MES",
  b1.id_botiga "BOTIGA", 
  SUM(v1.quantitat) "Q.T.PROD",
  COUNT( DISTINCT v1.id_prod) "N.DF.PROD",
  SUM(v1.benefici_net * v1.quantitat) "BN.T",
  ROUND((SUM(v1.benefici_net * v1.quantitat) * 100) / (select SUM(v2.benefici_net * v2.quantitat)
                                  			FROM dwh_venda v2
                                        		WHERE TO_CHAR(v2.id_data,'YYYY') = &anno  
                                              		  and TO_CHAR(v2.id_data,'MM') = &mmes) ,2) "% BN.B / BN.C",
  ROUND(SUM(v1.benefici_net * v1.quantitat) / (SELECT b2.treballadors 
                          			FROM botiga b2
                          			WHERE b2.id_botiga = b1.id_botiga),2) "BN.T / TB"
FROM dwh_venda v1, botiga b1
WHERE b1.id_botiga = v1.id_botiga
   and TO_CHAR(v1.id_data,'YYYY') = &anno  
   and TO_CHAR(v1.id_data,'MM') = &mmes
GROUP BY b1.id_botiga,
  TO_CHAR(v1.id_data,'YYYY'),
  TO_CHAR(v1.id_data,'MM')
ORDER BY SUM(v1.BENEFICI_NET) DESC;

spool off;

