---------------------------------------------------------------------------------
-- Alumne: Miguel Alvarez Lopez (bluesea)
-- Consultor: Juan Martnez Bolaos
-- Projecte: GESTIO D'UN DATA WAREHOUSE PER UNA CADENA DE BOTIGUES DE ROBA
---------------------------------------------------------------------------------

spool III_2_b_Consulta_b.log;

/*****************************************************************
-- Nom:                 CONSANYMESPRODUCTE
--
-- Descripci:          obtenir unes dades, donat un any i un mes concret com a parmetres d'entrada: el llistat
--                      de tots els productes del catleg.
--
-- Parmetres entrada: ANY, MES
--
*****************************************************************/

SET LINESIZE 150
SET PAGESIZE 25

DEF anyo = '2014';
DEF mes = '04'; 

-- Comentari: els valors de milers vindran marcats per una "," i els decimals per un "."
COLUMN BENEFICINET FORMAT 999,990 HEADING "BENEFICI NET";

SELECT
  TO_CHAR(v2.id_data,'YYYY') AS anyo,
  TO_CHAR(v2.id_data,'MM') AS mes,  
  pd2.id_prod "EAN13",
  pd2.descripcio "DESCRIPCIO PROD.",
  t3.quantitat "QUANTITAT",
  SUM(v2.quantitat) * v2.benefici_net AS BENEFICINET,
  v2.id_botiga "BOTIGA",
  sum(v2.quantitat) "MAX QUANTITAT BOTIGA"
FROM productes pd2, dwh_venda v2,
  (
  -- obtenemos el maximo de cantidad vendida en alguna de las tiendas.  
  SELECT
    anyo,
    mes,
    id_prod,
    max(quantitat) as quantitat
  FROM
    (
    SELECT
        TO_CHAR(v3.id_data,'YYYY') AS anyo,
        TO_CHAR(v3.id_data,'MM') AS mes,  
        pd3.id_prod,
        v3.id_botiga,
        sum(v3.quantitat) as quantitat
    FROM
        productes pd3,
        dwh_venda v3
    WHERE pd3.id_prod = v3.id_prod
    AND TO_CHAR(v3.id_data,'YYYY') = &anyo
    AND TO_CHAR(v3.id_data,'MM') = &mes
    GROUP BY 
        TO_CHAR(v3.id_data,'YYYY'),
        TO_CHAR(v3.id_data,'MM'),
        pd3.id_prod, 
        v3.id_botiga
  )
GROUP BY
  anyo,
  mes,
  id_prod
) t3
WHERE pd2.id_prod = v2.id_prod
  AND pd2.id_prod = t3.id_prod
  AND TO_CHAR(v2.id_data,'YYYY') = t3.anyo
  AND TO_CHAR(v2.id_data,'MM') = t3.mes
GROUP BY 
  TO_CHAR(v2.id_data,'YYYY'),
  TO_CHAR(v2.id_data,'MM'),
  pd2.id_prod,
  pd2.descripcio,
  t3.quantitat,
  v2.id_botiga,
  v2.benefici_net
HAVING
  sum(v2.quantitat) = t3.quantitat
ORDER BY SUM(v2.quantitat) * v2.benefici_net DESC;

spool off;