---------------------------------------------------------------------------------
-- Alumne: Miguel Alvarez Lopez (bluesea)
-- Consultor: Juan Martnez Bolaos
-- Projecte: GESTIO D'UN DATA WAREHOUSE PER UNA CADENA DE BOTIGUES DE ROBA
---------------------------------------------------------------------------------

spool III_2_b_Consulta_c.log;

/*****************************************************************
-- Nom:                 CONSANYMESDIAMES
--
-- Descripci:          obtenir unes dades, donat un any i un mes concret el llistat
--                      de tots els dies del mes

--
-- Parmetres entrada: --
--
*****************************************************************/

SET LINESIZE 150
SET PAGESIZE 25

DEF anyo = '2015';
DEF mes = '11';

-- Comentari: els valors de milers vindran marcats per una "," i els decimals per un "."
COLUMN ANYO FORMAT 9,990 HEADING 'ANY';
COLUMN MES FORMAT 90 HEADING 'MES';
COLUMN DIA FORMAT 90 HEADING 'DIA';
COLUMN BENEFICI_NET_TOTAL FORMAT 999,990 HEADING 'BENEFICI NET TOTAL';
COLUMN UNITATS_VENUDES FORMAT 999,999 HEADING 'UNITATS VENUDES';
COLUMN BNETBOTIGA FORMAT 999,999 HEADING 'B.NET BOTIGA';

SELECT
  t1.anyo,
  t1.mes,
  t1.dia,
  t1.benefici_net_total,
  t2.ean13,
  t2.unitats_venudes,
  t3.botiga,
  t3.bnetbotiga
FROM
(
  SELECT 
    TO_CHAR(v1.id_data,'YYYY') AS ANYO,
    TO_CHAR(v1.id_data,'MM') AS MES,  
    TO_CHAR(v1.id_data,'DD') AS DIA,
    SUM(v1.quantitat * v1.benefici_net) AS  BENEFICI_NET_TOTAL
  FROM dwh_venda v1
  WHERE TO_CHAR(v1.id_data,'YYYY') = &anyo  
      AND TO_CHAR(v1.id_data,'MM') = &mes
  GROUP BY 
      TO_CHAR(v1.id_data,'YYYY'),
      TO_CHAR(v1.id_data,'MM'),
      TO_CHAR(v1.id_data,'DD')
) t1,
(
  SELECT
    TO_CHAR(v2.id_data,'YYYY') AS anyo,
    TO_CHAR(v2.id_data,'MM') AS mes,  
    TO_CHAR(v2.id_data,'DD') AS dia,
    v2.id_prod AS EAN13,
    SUM(v2.quantitat) AS unitats_venudes
  FROM dwh_venda v2,
      (
      SELECT 
        anyo,
        mes,  
        dia,
        MAX(quantitat) AS max_quantitat
      FROM
        (
            SELECT
              TO_CHAR(v3.id_data,'YYYY') AS anyo,
              TO_CHAR(v3.id_data,'MM') AS mes,  
              TO_CHAR(v3.id_data,'DD') AS dia,
              v3.id_prod AS EAN13,
              SUM(v3.quantitat) AS quantitat
            FROM dwh_venda v3
            WHERE TO_CHAR(v3.id_data,'YYYY') = &anyo  
                AND TO_CHAR(v3.id_data,'MM') = &mes
            GROUP BY 
                TO_CHAR(v3.id_data,'YYYY'),
                TO_CHAR(v3.id_data,'MM'),
                TO_CHAR(v3.id_data,'DD'),
                v3.id_prod
          )
      GROUP BY 
         anyo,
         mes,
         dia
         ) t3
      WHERE TO_CHAR(v2.id_data,'YYYY') = t3.anyo
      AND TO_CHAR(v2.id_data,'MM') = t3.mes
      AND TO_CHAR(v2.id_data,'DD') = t3.dia
      GROUP BY 
          TO_CHAR(v2.id_data,'YYYY'),
          TO_CHAR(v2.id_data,'MM'),
          TO_CHAR(v2.id_data,'DD'),
          v2.id_prod,
          t3.max_quantitat
     having SUM(v2.quantitat) = t3.max_quantitat
) t2,
(
SELECT
        TO_CHAR(v2.id_data,'YYYY') AS anyo,
        TO_CHAR(v2.id_data,'MM') AS mes,  
        TO_CHAR(v2.id_data,'DD') AS dia,
        v2.id_botiga AS botiga,
        SUM(v2.quantitat * v2.benefici_net) AS bnetbotiga
FROM dwh_venda v2,
      (
SELECT 
  anyo,
  mes,  
  dia,
  MAX(bnetbotiga) AS max_botiga
FROM
  (
      SELECT
        TO_CHAR(v3.id_data,'YYYY') AS anyo,
        TO_CHAR(v3.id_data,'MM') AS mes,  
        TO_CHAR(v3.id_data,'DD') AS dia,
        v3.id_botiga AS botiga,
        SUM(v3.quantitat * v3.benefici_net) AS bnetbotiga
      FROM dwh_venda v3
      WHERE TO_CHAR(v3.id_data,'YYYY') = &anyo  
          AND TO_CHAR(v3.id_data,'MM') = &mes
      GROUP BY 
          TO_CHAR(v3.id_data,'YYYY'),
          TO_CHAR(v3.id_data,'MM'),
          TO_CHAR(v3.id_data,'DD'),
          v3.id_botiga
    )
GROUP BY 
   anyo,
   mes,
   dia
   ) t3
WHERE
  TO_CHAR(v2.id_data,'YYYY') = t3.anyo
  AND TO_CHAR(v2.id_data,'MM') = t3.mes
  AND TO_CHAR(v2.id_data,'DD') = t3.dia
GROUP BY 
          TO_CHAR(v2.id_data,'YYYY'),
          TO_CHAR(v2.id_data,'MM'),
          TO_CHAR(v2.id_data,'DD'),
          v2.id_botiga,
          t3.max_botiga
having SUM(v2.quantitat * v2.benefici_net) = t3.max_botiga
) t3
WHERE t1.anyo = t2.anyo
AND t2.anyo = t3.anyo
AND t1.mes = t2.mes
AND t2.mes = t3.mes
AND t1.dia = t2.dia
AND t2.dia = t3.dia
ORDER BY anyo,
         mes,
         dia;

spool off;