---------------------------------------------------------------------------------
-- Alumne: Miguel Alvarez Lopez (bluesea)
-- Consultor: Juan Martnez Bolaos
-- Projecte: GESTIO D'UN DATA WAREHOUSE PER UNA CADENA DE BOTIGUES DE ROBA
---------------------------------------------------------------------------------

spool II-4-3-4_CreacioTaules_DWH.log;

-- Creaci de Taules DWH

/*==============================================================*/
/* Table: DWH_VENDA                                             */
/*==============================================================*/
CREATE TABLE DWH_VENDA (
  ID_BOTIGA		NUMBER(3)	NOT NULL,
  ID_PROD		VARCHAR2(13)	NOT NULL,
  ID_DATA		DATE		NOT NULL,
  ID_HORA		NUMBER(2)	NOT NULL,
  QUANTITAT		NUMBER		NOT NULL,
  PREU_BRUT		NUMBER		NOT NULL,
  BENEFICI_NET		NUMBER		NOT NULL,
 CONSTRAINT PK_DWH_VENDA PRIMARY KEY(ID_BOTIGA, ID_PROD, ID_DATA, ID_HORA),
 CONSTRAINT FK1_DWH_VENDA_BOTIGA FOREIGN KEY(ID_BOTIGA) REFERENCES BOTIGA(ID_BOTIGA),
 CONSTRAINT FK2_DWH_VENDA_PRODUCTES FOREIGN KEY(ID_PROD) REFERENCES PRODUCTES(ID_PROD)
);

comment on table DWH_VENDA is
'Vendes diaries de les botigues que formen part de la cadena de roba';

comment on column DWH_VENDA.ID_DATA is
'Data en format ddmmaaaa';

comment on column DWH_VENDA.ID_HORA is
'Hora sense minuts (hh) en format 24 hores';

/*==============================================================*/
/* Table: DWH_EST                                               */
/*==============================================================*/
CREATE TABLE DWH_EST (
  ANYO			NUMBER(4)	NOT NULL,
  BNET_CAD		NUMBER		NULL,
  BOTIGA_MES_BNET	NUMBER(3)	NULL,
  BNET_BOT		NUMBER		NULL,
  ID_PROD		VARCHAR2(13)	NULL,
  QUANT_PROD		NUMBER		NULL,
  HORA_MES_PROD		VARCHAR2(50)	NULL,
  Q_HORA_MES_PROD	NUMBER		NULL,
  HORA_MENYS_PROD	VARCHAR2(50)	NULL,
  Q_HORA_MENYS_PROD	NUMBER		NULL,
  DIA_MES_VENDA		VARCHAR2(50)	NULL,
  Q_DIA_MES_VENDA	NUMBER		NULL,
  DIA_MENYS_VENDA	VARCHAR2(50)	NULL,
  Q_DIA_MENYS_VENDA	NUMBER		NULL,
  CIUTAT_MES_BNET	VARCHAR2(25)	NULL,
  BNET_CIUTAT		NUMBER		NULL,
  TPC_BNET_BVIRTUALS	NUMBER		NULL,
 CONSTRAINT PK_DWH_EST PRIMARY KEY(ANYO)
 );

comment on table DWH_EST is
'Taula que contindra, per a cada any de vendes, el calcul de les 9 consultes del modul estadistic';

comment on column DWH_EST.ANYO is 
'ANYO EN FORMAT AAAA';

comment on column DWH_EST.HORA_MES_PROD is
'Si hi ha mes d un valor, esta separat per ";" (Ex: ;10;14;17)';

comment on column DWH_EST.HORA_MENYS_PROD is
'Si hi ha mes d un valor, esta separat per ";" (Ex: ;10;14;17)';

comment on column DWH_EST.DIA_MES_VENDA is
'Si hi ha mes d un valor, esta separat per ";" (Ex: ;10;23;30)';

comment on column DWH_EST.DIA_MENYS_VENDA is
'Si hi ha mes d un valor, esta separat per ";" (Ex: ;10;23;30)';

spool off;