---------------------------------------------------------------------------------
-- Alumne: Miguel Alvarez Lopez (bluesea)
-- Consultor: Juan Martnez Bolaos
-- Projecte: GESTIO D'UN DATA WAREHOUSE PER UNA CADENA DE BOTIGUES DE ROBA
---------------------------------------------------------------------------------


/*****************************************************************
-- Nom: BNETTOTAL                
--
-- Descripci:          consulta el benefici net de tota la cadena per un any concret
--
-- Tasca: CU017-01
--
-- Parmetres entrada:
--						pANYO DWH_EST.ANYO%TYPE
--
-- Error controlats:   
--
*****************************************************************/
CREATE OR REPLACE FUNCTION BNETTOTAL ( 
                                        pANYO DWH_EST.ANYO%TYPE)
					RETURN NUMBER
  IS
    pBNET_CAD NUMBER;
  
BEGIN
  SELECT 
	BNET_CAD
  INTO
	pBNET_CAD
  FROM DWH_EST
  WHERE ANYO = pANYO;

  RETURN pBNET_CAD;
END;
/

/*****************************************************************
-- Nom: BOTIGAMESBNET               
--
-- Descripci:          consulta la botiga amb mes benefici net per un any concret
--
-- Tasca: CU017-02
--
-- Parmetres entrada:
--						pANYO DWH_EST.ANYO%TYPE
--
-- Error controlats:   
--
*****************************************************************/
CREATE OR REPLACE FUNCTION BOTIGAMESBNET ( 
                                        pANYO DWH_EST.ANYO%TYPE)
					RETURN VARCHAR2

  IS
    pBOTIGAMESBNET VARCHAR2(150);
    pBOTIGA_MES_BNET NUMBER(3);
    pBNET_BOT NUMBER;

BEGIN
  SELECT 
	BOTIGA_MES_BNET,
	BNET_BOT
  INTO
	pBOTIGA_MES_BNET,
	pBNET_BOT
  FROM DWH_EST
  WHERE ANYO = pANYO;

  pBOTIGAMESBNET := 'BOTIGA: '|| pBOTIGA_MES_BNET || ' BENEFICI NET: ' || pBNET_BOT;

  RETURN pBOTIGAMESBNET;
END;
/

/*****************************************************************
-- Nom: PRODMESVENUT             
--
-- Descripci:          consulta el producte mes venut per un any concret
--
-- Tasca: CU018-01
--
-- Parmetres entrada:
--						pANYO DWH_EST.ANYO%TYPE
--
-- Error controlats:   
--
*****************************************************************/
CREATE OR REPLACE FUNCTION PRODMESVENUT ( 
                                        pANYO DWH_EST.ANYO%TYPE)
					RETURN VARCHAR2

  IS
    pPRODMESVENUT VARCHAR2(100);
    pID_PROD VARCHAR2(13);
    pQUANT_PROD NUMBER;

BEGIN
  SELECT 
	ID_PROD,
	QUANT_PROD
  INTO
	pID_PROD,
	pQUANT_PROD
  FROM DWH_EST
  WHERE ANYO = pANYO;

  pPRODMESVENUT := 'PRODUCTE: '|| pID_PROD || ' QUANTITAT VENUDA: ' || pQUANT_PROD;

  RETURN pPRODMESVENUT;
END;
/

/*****************************************************************
-- Nom: HORAMESPRODVENUT            
--
-- Descripci:          consulta hora mes productes venuts per un any concret
--
-- Tasca: CU018-02
--
-- Parmetres entrada:
--						pANYO DWH_EST.ANYO%TYPE
--
-- Error controlats:   
--
*****************************************************************/
CREATE OR REPLACE FUNCTION HORAMESPRODVENUT ( 
                                        pANYO DWH_EST.ANYO%TYPE)
					RETURN VARCHAR2

  IS
    pHORAMESPRODVENUT VARCHAR2(200);
    pHORA_MES_PROD NUMBER;
    pQ_HORA_MES_PROD NUMBER;

BEGIN
  SELECT 
	HORA_MES_PROD,
	Q_HORA_MES_PROD
  INTO
	pHORA_MES_PROD,
	pQ_HORA_MES_PROD
  FROM DWH_EST
  WHERE ANYO = pANYO;

  pHORAMESPRODVENUT := 'HORA: '|| pHORA_MES_PROD || ' QUANTITAT VENUDA: ' || pQ_HORA_MES_PROD;

  RETURN pHORAMESPRODVENUT;
END;
/

/*****************************************************************
-- Nom: HORAMENYSPRODVENUT            
--
-- Descripci:          consulta hora menys productes venuts per un any concret
--
-- Tasca: CU018-03
--
-- Parmetres entrada:
--						pANYO DWH_EST.ANYO%TYPE
--
-- Error controlats:   
--
*****************************************************************/
CREATE OR REPLACE FUNCTION HORAMENYSPRODVENUT ( 
                                        pANYO DWH_EST.ANYO%TYPE)
					RETURN VARCHAR2

  IS
    pHORAMENYSPRODVENUT VARCHAR2(200);
    pHORA_MENYS_PROD NUMBER;
    pQ_HORA_MENYS_PROD NUMBER;

BEGIN
  SELECT 
	HORA_MENYS_PROD,
	Q_HORA_MENYS_PROD
  INTO
	pHORA_MENYS_PROD,
	pQ_HORA_MENYS_PROD
  FROM DWH_EST
  WHERE ANYO = pANYO;

  pHORAMENYSPRODVENUT := 'HORA: '|| pHORA_MENYS_PROD || ' QUANTITAT VENUDA: ' || pQ_HORA_MENYS_PROD;

  RETURN pHORAMENYSPRODVENUT;
END;
/

/*****************************************************************
-- Nom: DIAMESVENDES            
--
-- Descripci:          consulta dia mes vendes realitzades per un any concret
--
-- Tasca: CU019-01
--
-- Parmetres entrada:
--						pANYO DWH_EST.ANYO%TYPE
--
-- Error controlats:   
--
*****************************************************************/
CREATE OR REPLACE FUNCTION DIAMESVENDES ( 
                                        pANYO DWH_EST.ANYO%TYPE)
					RETURN VARCHAR2

  IS
    pDIAMESVENDES VARCHAR2(200);
    pDIA_MES_VENDA NUMBER;
    pQ_DIA_MES_VENDA NUMBER;

BEGIN
  SELECT 
	DIA_MES_VENDA,
	Q_DIA_MES_VENDA
  INTO
	pDIA_MES_VENDA,
	pQ_DIA_MES_VENDA
  FROM DWH_EST
  WHERE ANYO = pANYO;

  pDIAMESVENDES := 'DIA: '|| pDIA_MES_VENDA || ' QUANTITAT VENDES: ' || pQ_DIA_MES_VENDA;

  RETURN pDIAMESVENDES;
END;
/

/*****************************************************************
-- Nom: DIAMENYSVENDES            
--
-- Descripci:          consulta dia menys vendes realitzades per un any concret
--
-- Tasca: CU019-02
--
-- Parmetres entrada:
--						pANYO DWH_EST.ANYO%TYPE
--
-- Error controlats:   
--
*****************************************************************/
CREATE OR REPLACE FUNCTION DIAMENYSVENDES ( 
                                        pANYO DWH_EST.ANYO%TYPE)
					RETURN VARCHAR2

  IS
    pDIAMENYSVENDES VARCHAR2(200);
    pDIA_MENYS_VENDA NUMBER;
    pQ_DIA_MENYS_VENDA NUMBER;

BEGIN
  SELECT 
	DIA_MENYS_VENDA,
	Q_DIA_MENYS_VENDA
  INTO
	pDIA_MENYS_VENDA,
	pQ_DIA_MENYS_VENDA
  FROM DWH_EST
  WHERE ANYO = pANYO;

  pDIAMENYSVENDES := 'DIA: '|| pDIA_MENYS_VENDA || ' QUANTITAT VENDES: ' || pQ_DIA_MENYS_VENDA;

  RETURN pDIAMENYSVENDES;
END;
/

/*****************************************************************
-- Nom: CIUTATMESBNET            
--
-- Descripci:          consulta ciutat mes benefici net per un any concret
--
-- Tasca: CU017-02
--
-- Parmetres entrada:
--						pANYO DWH_EST.ANYO%TYPE
--
-- Error controlats:   
--
*****************************************************************/
CREATE OR REPLACE FUNCTION CIUTATMESBNET ( 
                                        pANYO DWH_EST.ANYO%TYPE)
					RETURN VARCHAR2

  IS
    pCIUTATMESBNET VARCHAR2(100);
    pCIUTAT_MES_BNET VARCHAR2(25);
    pBNET_CIUTAT NUMBER;

BEGIN
  SELECT 
	CIUTAT_MES_BNET,
	BNET_CIUTAT
  INTO
	pCIUTAT_MES_BNET,
	pBNET_CIUTAT
  FROM DWH_EST
  WHERE ANYO = pANYO;

  pCIUTATMESBNET := 'CIUTAT: '|| pCIUTAT_MES_BNET || ' BENEFICI NET: ' || pBNET_CIUTAT;

  RETURN pCIUTATMESBNET;
END;
/

/*****************************************************************
-- Nom: TPCBNETBVIRT             
--
-- Descripci:          consulta % benefici net de les botigues virtuals
--                      respecte total benefici net cadena, per un any concret
--
-- Tasca: CU017-04
--
-- Parmetres entrada:
--						pANYO DWH_EST.ANYO%TYPE
--
-- Error controlats:   
--
*****************************************************************/
CREATE OR REPLACE FUNCTION TPCBNETBVIRT ( 
                                        pANYO DWH_EST.ANYO%TYPE)
					RETURN NUMBER
  IS
    pTPC_BNET_BVIRTUALS	NUMBER;
  
BEGIN
  SELECT 
	TPC_BNET_BVIRTUALS
  INTO
	pTPC_BNET_BVIRTUALS
  FROM DWH_EST
  WHERE ANYO = pANYO;

  RETURN pTPC_BNET_BVIRTUALS;
END;
/