---------------------------------------------------------------------------------
-- Alumne: Miguel Alvarez Lopez (bluesea)
-- Consultor: Juan Martnez Bolaos
-- Projecte: GESTIO D'UN DATA WAREHOUSE PER UNA CADENA DE BOTIGUES DE ROBA
---------------------------------------------------------------------------------



/*****************************************************************
-- Nom:                 ALTALOG
--
-- Descripci:          Registra les crides fetes als procediments de l'apliactiu
--
-- Parmetres entrada:
					    pPROCEDIMENT LOGS.PROCEDIMENT%TYPE,
					    pPARAMS LOGS.PARAMS%TYPE,
					    pRESULTAT LOGS.RESULTAT%TYPE
--
-- Error controlats:   - LOG duplicat
--
*****************************************************************/
CREATE OR REPLACE PROCEDURE "ALTALOG" ( 
					   pPROCEDIMENT LOGS.PROCEDIMENT%TYPE,
					   pPARAMS LOGS.PARAMS%TYPE,
					   pRESULTAT LOGS.RESULTAT%TYPE) 					   
  AS

BEGIN   
  BEGIN
	INSERT INTO LOGS (ID_LOG,DATA,PROCEDIMENT,PARAMS,RESULTAT) 
	VALUES (TFC1.SEQ_LOGS.nextval,SYSDATE,pPROCEDIMENT,pPARAMS,pRESULTAT);
        
    EXCEPTION  
        WHEN DUP_VAL_ON_INDEX THEN
          DBMS_OUTPUT.PUT_LINE('Aquest log ja existeix.');
          ROLLBACK;

        WHEN OTHERS THEN
          DBMS_OUTPUT.PUT_LINE('Error en alta log: (' || SQLCODE || ') ' || SQLERRM);     
	  ROLLBACK;
  END;

COMMIT;
END;
/

